// -*- C++ -*-
#ifndef _cannaconv_h_included_
#define _cannaconv_h_included_

#include "kkconv.h"

#include <canna/jrkanji.h>

#define BUF_SIZE 1024

class CannaConv : public KKConv{
public:
  virtual ~CannaConv();
  KKContext *createContext(XimIC *);
  char **getIcon();
  void onPushIcon();

  void init();
private:
};

class CannaContext : public KKContext{
public:
  CannaContext(CannaConv *,XimIC *);
  void OnUpdatePe(pe_stat *);
  int push_key(keyState *e);
  int get_mode();
  void set_mode(int mode);
  jstring_t *clear();
  virtual ~CannaContext();
private:
  int proc_raw_mode(keyState *);

  int contextID;
  int mode;
  char buffer[BUF_SIZE];
  jrKanjiStatusWithValue ksv;
  jrKanjiStatus ks;

};

#endif
