// -*- C++ -*-
#ifndef _convdisp_h_included_
#define _convdisp_h_included_

// 
#define CAND_WIN_WIDTH 300
#define CAND_WIN_HEIGHT 300

#define CAND_COUNT 12

#include "heke.h"

class pe_line_win;
class pe_ov_win;

class KKContext;
class icxatr;
class CandidateWin;

class Convdisp{
public:
    Convdisp(KKContext *,icxatr *);
    virtual ~Convdisp();
    void set_pe(pe_stat *);
    virtual void update_preedit()=0;
    virtual void candidate_selected(int );
    virtual void update_icxatr()=0;
    virtual void set_focus(){};
    virtual void unset_focus(){};

    // methods for OnTheSpot
protected:
    // ownerXimIC,˥åȤ졢KKContextconvdisp
    // ȤXimICˤä˴롣
    KKContext *m_kkContext;
    icxatr *m_atr;
    // ǽ0
    pe_stat *m_pe;
    CandidateWin *m_cands_win;
};

Convdisp *create_convdisp(int style,KKContext *,icxatr *,Connection *);

#endif
/*
 * Local variables:
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 */
